
        INCLUDE   \masm32\include\masm32rt.inc

        EXTERNDEF _imp__GetCurrentProcess@0:PTR pr0

        .CODE

;-----------------------------------------------------------------------------

_main   PROC

;before modification

        print   chr$("Before modification:"),13,10

;normal API call

        print   chr$("      INVOKE GetCurrentProcess"),13,10

        print   chr$("Address: ")
        mov     esi,offset LabelA-5
        push    esi
        print   uhex$(esi)
        print   chr$(" Code: ")
        pop     esi
        mov     ecx,1
        call    Bites
        lodsd
        push    eax
        push    esi
        print   uhex$(eax)
        print   chr$("     CALL           ")
        pop     esi
        pop     eax
        add     eax,esi
        push    eax
        print   uhex$(eax),13,10

        print   chr$("Address: ")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$(" Code: ")
        pop     esi
        mov     ecx,2
        call    Bites
        lodsd
        push    eax
        print   uhex$(eax)
        print   chr$("  JMP  DWord Ptr [")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$("]"),13,10

        print   chr$("Address: ")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$(" Data: ")
        pop     esi
        lodsd
        print   uhex$(eax),13,10,13,10

;_imp__ API call

        print   chr$("      INVOKE _imp__GetCurrentProcess@0"),13,10

        print   chr$("Address: ")
        mov     esi,offset LabelB-6
        push    esi
        print   uhex$(esi)
        print   chr$(" Code: ")
        pop     esi
        mov     ecx,2
        call    Bites
        lodsd
        push    eax
        print   uhex$(eax)
        print   chr$("  CALL DWord Ptr [")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$("]"),13,10

        print   chr$("Address: ")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$(" Data: ")
        pop     esi
        lodsd
        print   uhex$(eax),13,10,13,10,13,10

;modify the normal call

        mov     esi,offset LabelA
        call    Relat

;modify the _imp__ call

        mov     esi,offset LabelB
        call    Relat

;after modification

        print   chr$(" After modification:"),13,10

;normal API call

        print   chr$("      INVOKE GetCurrentProcess"),13,10

        print   chr$("Address: ")
        mov     esi,offset LabelA-5
        push    esi
        print   uhex$(esi)
        print   chr$(" Code: ")
        pop     esi
        mov     esi,offset LabelA-5
        mov     ecx,1
        call    Bites
        lodsd
        push    eax
        push    esi
        print   uhex$(eax)
        print   chr$("     CALL           ")
        pop     esi
        pop     eax
        add     eax,esi
        push    eax
        print   uhex$(eax),13,10,13,10

;_imp__ API call

        print   chr$("      INVOKE _imp__GetCurrentProcess@0"),13,10

        print   chr$("Address: ")
        mov     esi,offset LabelB-6
        push    esi
        print   uhex$(esi)
        print   chr$(" Code: ")
        pop     esi
        mov     ecx,1
        call    Bites
        push    esi
        print   chr$("             NOP"),13,10

        print   chr$("Address: ")
        pop     eax
        push    eax
        print   uhex$(eax)
        print   chr$(" Code: ")
        pop     esi
        mov     ecx,1
        call    Bites
        lodsd
        push    eax
        push    esi
        print   uhex$(eax)
        print   chr$("     CALL           ")
        pop     esi
        pop     eax
        add     eax,esi
        print   uhex$(eax),13,10,13,10,13,10

;test results

        print   chr$("Function Test Results:"),13,10

;normal API call

        print   chr$("        GetCurrentProcess: ")
        INVOKE  GetCurrentProcess
LabelA  label   dword
        print   uhex$(eax),13,10

;_imp__ API call

        print   chr$("_imp__GetCurrentProcess@0: ")
        INVOKE  _imp__GetCurrentProcess@0
LabelB  label   dword
        print   uhex$(eax),13,10

;terminate

        exit

_main   ENDP

;-----------------------------------------------------------------------------

Relat   PROC

;Adjust the CALL address of an INVOKE to eliminate the IAT JMP

;Call With: ESI = address of code just after the INVOKE

;  Returns: modifies the address of the INVOKE

        sub     esi,6
        push    esi
        sub     esp,4
        INVOKE  VirtualProtect,
                esi,
                6,
                PAGE_EXECUTE_READWRITE,
                esp
        pop     edx
        pop     esi
        or      eax,eax
        jz      Relat3

        cld
        lodsw
        cmp     ah,0E8h
        jz      Relat0

        cmp     ax,15FFh
        lodsd
        jnz     Relat2

        mov word ptr [esi-6],0E890h
        jmp short Relat1

Relat0: lodsd
        add     eax,esi
        push    esi
        xchg    eax,esi
        lodsw
        cmp     ax,25FFh
        lodsd
        pop     esi
        jnz     Relat2

Relat1: mov     eax,[eax]
        sub     eax,esi
        mov     [esi-4],eax

Relat2: sub     esi,6
        sub     esp,4
        INVOKE  VirtualProtect,
                esi,
                6,
                edx,
                esp
        add     esp,4

Relat3: ret

Relat   ENDP

;-----------------------------------------------------------------------------

Bites   PROC

Bites0: cld
        lodsb
        push    ecx
        push    esi
        print   right$(uhex$(eax),2),20h
        pop     esi
        pop     ecx
        loop    Bites0
        ret

Bites   ENDP

;-----------------------------------------------------------------------------

        END     _main
